%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function [Repaired_Offset_MPC_Counter, Created_Offset_MPC_Counter, Repaired_Offsets_Counter] = Repair_RutFast_Offsets(Fastener_Index)

global ErrCode;

global DB_NODES;
global DB_MPC;

global AT_NODES;
global AT_MPC;

global db_Next_Node_Number;
global db_Next_MPC_Number;

global DB_FASTENERS;

% Инициализация счетчиков
Repaired_Offset_MPC_Counter = 0;
Created_Offset_MPC_Counter = 0;
Repaired_Offsets_Counter = 0;

% Получение оси болта
[Axis_Point_1, Axis_Point_2, Axis_vector] = Get_Fastener_Axis(Fastener_Index);

if (ErrCode < 0)
    return;
end

% Цикл по ярусам
for j=1:DB_FASTENERS{Fastener_Index}.N_layers

    % Проверка MPC для офсета
    if (~isempty(DB_FASTENERS{Fastener_Index}.Offset_MPCs{j}))

        % Если порядок узлов не такой, как нужно
        if (DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.Offset_MPCs{j})}.ind_grid == DB_FASTENERS{Fastener_Index}.Joint_nodes(j))

            % Меняем узлы в MPC местами
            MPC_ID = DB_FASTENERS{Fastener_Index}.Offset_MPCs{j};
            Ind_Node = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.Offset_MPCs{j})}.dep_grid(1);
            Dep_Node_list = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.Offset_MPCs{j})}.ind_grid;
            Dep_DOFs = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.Offset_MPCs{j})}.dep_DOF;

            Append_To_Output(PCL_MPC_Modify_RBE2(MPC_ID, Ind_Node, Dep_Node_list, Dep_DOFs));
            DB_MPC_Modify_RBE2(MPC_ID, Ind_Node, Dep_Node_list, Dep_DOFs);

            if (ErrCode < 0)
                return;
            end

            Repaired_Offset_MPC_Counter = Repaired_Offset_MPC_Counter + 1;

        end

    else

        % Создаем MPC для офсета

        % Создание нового узла
        Reference_Coord = DB_NODES{AT_NODES(DB_FASTENERS{Fastener_Index}.Joint_nodes(j))}.Reference_CID;
        Analysis_Coord = DB_NODES{AT_NODES(DB_FASTENERS{Fastener_Index}.Joint_nodes(j))}.Analysis_CID;
        Location = DB_FASTENERS{Fastener_Index}.Joint_nodes(j);

        Append_To_Output(PCL_Node_Create(Reference_Coord, Analysis_Coord, Location));
        Created_Node_ID = DB_Node_Create(Reference_Coord, Analysis_Coord, Location);
        db_Next_Node_Number = db_Next_Node_Number + 1;

        if (ErrCode < 0)
            return;
        end

        % Отсоединение болта от текущего яруса сетки
        Element_list = DB_FASTENERS{Fastener_Index}.Bush_elements{j};
        Node_list = DB_FASTENERS{Fastener_Index}.Additional_nodes(j);
        Target_Node_list = Created_Node_ID;

        Append_To_Output(PCL_Elm_Modify_Conn(Element_list, Node_list, Target_Node_list));
        DB_Elm_Modify_Conn(Element_list, Node_list, Target_Node_list);

        if (ErrCode < 0)
            return;
        end

        MPC_ID = DB_FASTENERS{Fastener_Index}.RBAR_MPCs(j);
        if (DB_FASTENERS{Fastener_Index}.Additional_nodes(j) == DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.RBAR_MPCs(j))}.ind_grid)
            Ind_Node = Created_Node_ID;
            Dep_Node = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.RBAR_MPCs(j))}.dep_grid;
            Dep_DOFs = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.RBAR_MPCs(j))}.dep_DOF;
        else
            Ind_Node = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.RBAR_MPCs(j))}.ind_grid;
            Dep_Node = Created_Node_ID;
            Dep_DOFs = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.RBAR_MPCs(j))}.dep_DOF;
        end

        Append_To_Output(PCL_MPC_Modify_RBAR(MPC_ID, Ind_Node, Dep_Node, Dep_DOFs));
        DB_MPC_Modify_RBAR(MPC_ID, Ind_Node, Dep_Node, Dep_DOFs);

        if (ErrCode < 0)
            return;
        end

        MPC_ID = DB_FASTENERS{Fastener_Index}.RBAR_MPCs(j+1);
        if (DB_FASTENERS{Fastener_Index}.Additional_nodes(j) == DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.RBAR_MPCs(j+1))}.ind_grid)
            Ind_Node = Created_Node_ID;
            Dep_Node = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.RBAR_MPCs(j+1))}.dep_grid;
            Dep_DOFs = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.RBAR_MPCs(j+1))}.dep_DOF;
        else
            Ind_Node = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.RBAR_MPCs(j+1))}.ind_grid;
            Dep_Node = Created_Node_ID;
            Dep_DOFs = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.RBAR_MPCs(j+1))}.dep_DOF;
        end

        Append_To_Output(PCL_MPC_Modify_RBAR(MPC_ID, Ind_Node, Dep_Node, Dep_DOFs));
        DB_MPC_Modify_RBAR(MPC_ID, Ind_Node, Dep_Node, Dep_DOFs);

        if (ErrCode < 0)
            return;
        end

        % Создание MPC для офсета
        Ind_Node = Created_Node_ID;
        Dep_Node_list = DB_FASTENERS{Fastener_Index}.Joint_nodes(j);
        Dep_DOFs = 123456;

        Append_To_Output(PCL_MPC_Create_RBE2(Ind_Node, Dep_Node_list, Dep_DOFs));
        Created_MPC_ID = DB_MPC_Create_RBE2(Ind_Node, Dep_Node_list, Dep_DOFs);
        db_Next_MPC_Number = db_Next_MPC_Number + 1;

        if (ErrCode < 0)
            return;
        end

        % Внесение изменений в базу данных крепежа
        DB_FASTENERS{Fastener_Index}.Additional_nodes(j) = Created_Node_ID;
        DB_FASTENERS{Fastener_Index}.Offset_MPCs{j} = Created_MPC_ID;   

        Created_Offset_MPC_Counter = Created_Offset_MPC_Counter + 1;

    end

    % Получение точки срединной поверхности текущего яруса
    Midsurface_Point = Get_Plate_Midsurf_Point(Fastener_Index, j, Axis_Point_1, Axis_Point_2, Axis_vector);

    if (ErrCode < 0)
        return;
    end

    Change_Flag = 0;

    % Проверка узла стержня болта
    if (~Equiv_Check_Cube(DB_FASTENERS{Fastener_Index}.Shank_nodes(j+1), Midsurface_Point))

        % Перемещение узла на срединную поверхность
        Append_To_Output(PCL_Node_Move(DB_FASTENERS{Fastener_Index}.Shank_nodes(j+1), Midsurface_Point));
        DB_Node_Move(DB_FASTENERS{Fastener_Index}.Shank_nodes(j+1), Midsurface_Point);

        if (ErrCode < 0)
            return;
        end

        Change_Flag = 1;

    end

    % Проверка дополнительного узла
    if (~Equiv_Check_Cube(DB_FASTENERS{Fastener_Index}.Additional_nodes(j), Midsurface_Point))

        % Перемещение узла на срединную поверхность
        Append_To_Output(PCL_Node_Move(DB_FASTENERS{Fastener_Index}.Additional_nodes(j), Midsurface_Point));
        DB_Node_Move(DB_FASTENERS{Fastener_Index}.Additional_nodes(j), Midsurface_Point);

        if (ErrCode < 0)
            return;
        end

        Change_Flag = 1;

    end

    % Проверка первого концевого узла
    if (j == 1)

        % Получение точек для расчета направления
        Point_1 = Get_Plate_Midsurf_Point(Fastener_Index, j, Axis_Point_1, Axis_Point_2, Axis_vector);

        if (ErrCode < 0)
            return;
        end

        Point_2 = Get_Plate_Midsurf_Point(Fastener_Index, DB_FASTENERS{Fastener_Index}.N_layers-j+1, Axis_Point_1, Axis_Point_2, Axis_vector);

        if (ErrCode < 0)
            return;
        end

        if (Equiv_Check_Cube(Point_1, Point_2))
            fprintf (1, '\nОшибка: нулевое расстояние между крайними срединными точками в болте Рутмана с номером %i !\n', Fastener_Index);
            ErrCode = -1;
            return;
        end

        % Получение знака
        Sign = sign(dot(Point_1 - Point_2, Axis_vector));

        % Толщина текущего яруса
        Plate_Thickness = Get_Plate_Thickness(Fastener_Index, j, Axis_Point_1, Axis_Point_2);

        if (ErrCode < 0)
            return;
        end

        % Координаты целевой точки
        Target_Location = Midsurface_Point + Plate_Thickness/2 * Axis_vector * Sign;

        % Проверка концевого узла
        if (~Equiv_Check_Cube(DB_FASTENERS{Fastener_Index}.Shank_nodes(1), Target_Location))

            % Перемещение узла
            Append_To_Output(PCL_Node_Move(DB_FASTENERS{Fastener_Index}.Shank_nodes(1), Target_Location));
            DB_Node_Move(DB_FASTENERS{Fastener_Index}.Shank_nodes(1), Target_Location);

            if (ErrCode < 0)
                return;
            end

            Change_Flag = 1;

        end

    end

    % Проверка второго концевого узла
    if (j == DB_FASTENERS{Fastener_Index}.N_layers)

        % Получение точек для расчета направления
        Point_1 = Get_Plate_Midsurf_Point(Fastener_Index, j, Axis_Point_1, Axis_Point_2, Axis_vector);

        if (ErrCode < 0)
            return;
        end

        Point_2 = Get_Plate_Midsurf_Point(Fastener_Index, DB_FASTENERS{Fastener_Index}.N_layers-j+1, Axis_Point_1, Axis_Point_2, Axis_vector);

        if (ErrCode < 0)
            return;
        end

        if (Equiv_Check_Cube(Point_1, Point_2))
            fprintf (1, '\nОшибка: нулевое расстояние между крайними срединными точками в болте Рутмана с номером %i !\n', Fastener_Index);
            ErrCode = -1;
            return;
        end

        % Получение знака
        Sign = sign(dot(Point_1 - Point_2, Axis_vector));

        % Толщина текущего яруса
        Plate_Thickness = Get_Plate_Thickness(Fastener_Index, j, Axis_Point_1, Axis_Point_2);

        if (ErrCode < 0)
            return;
        end

        % Координаты целевой точки
        Target_Location = Midsurface_Point + Plate_Thickness/2 * Axis_vector * Sign;

        % Проверка концевого узла
        if (~Equiv_Check_Cube(DB_FASTENERS{Fastener_Index}.Shank_nodes(DB_FASTENERS{Fastener_Index}.N_layers+2), Target_Location))

            % Перемещение узла
            Append_To_Output(PCL_Node_Move(DB_FASTENERS{Fastener_Index}.Shank_nodes(DB_FASTENERS{Fastener_Index}.N_layers+2), Target_Location));
            DB_Node_Move(DB_FASTENERS{Fastener_Index}.Shank_nodes(DB_FASTENERS{Fastener_Index}.N_layers+2), Target_Location);

            if (ErrCode < 0)
                return;
            end

            Change_Flag = 1;

        end

    end

    % Обновление счетчика
    if (Change_Flag == 1)
        Repaired_Offsets_Counter = Repaired_Offsets_Counter + 1;
    end

end
